#include<bits/stdc++.h>
using namespace std;
const int maxn = 3e5+3;
const int K = 5;
int i,j,p,q,n,m,k,Q,ans[maxn],br,a[maxn];
int cnt[maxn],vr[maxn];
vector <int> sr[maxn];
struct Query
{
    int l,r,k,id;
} b[maxn];
vector <int> candidates[maxn];
void try_inserting(int ind)
{

    for(auto k:candidates[ind])
    {
        if(k==a[ind])return ;
    }

    candidates[ind].push_back(a[ind]);



    if(candidates[ind].size()>K)
    {

        int pos_min = 0,fr = INT_MAX;

        for(int k=0; k<candidates[ind].size(); k++)
        {
            int q = candidates[ind][k];
            if(cnt[q]<fr)
            {
                fr = cnt[q];
                pos_min = k;
            }
        }
        candidates[ind].erase(candidates[ind].begin()+pos_min);

    }
}
void calc(int st,int fin,int stupka)
{
    ++br;
    int pr;
    for(int j=st; j!=fin; j+=stupka)
        candidates[j].clear();
    for(int j=st; j!=fin; j+=stupka)
    {
        if(vr[a[j]]!=br)
            vr[a[j]] = br,cnt[a[j]] = 0;
        cnt[a[j]]++;
        if(j!=st)
        {
            for(auto k:candidates[pr])
                candidates[j].push_back(k);
        }
        try_inserting(j);
        pr = j;
    }
}

int freq(int l,int r,int val)
{
    int rb = upper_bound(sr[val].begin(),sr[val].end(),r)-sr[val].begin()-1;
    int lb = lower_bound(sr[val].begin(),sr[val].end(),l)-sr[val].begin();
    rb = min((int)sr[val].size()-1,rb);
    rb = max(rb,0);
    lb = min((int)sr[val].size()-1,lb);
    lb = max(lb,0);
    return rb-lb+1;
}
void solve(int l,int r,vector <int> v)
{
    if(r<l || v.empty())return ;
    if(l==r)
    {
        for(auto i:v)
            ans[b[i].id] = a[b[i].l];
        return ;
    }
    int mid = (l+r)/2;

    vector <vector <int>> to;
    to.resize(2);
    vector <int> now;

    for(auto i:v)
    {
        if(b[i].l<=mid && b[i].r>=mid)
            now.push_back(i);
        else
            to[b[i].l<mid].push_back(i);
    }

    calc(mid+1,r+1,+1);
    calc(mid,l-1,-1);

    for(auto i:now)
    {
        p = b[i].l;
        q = b[i].r;
        for(auto j:candidates[p])
        {
            k = freq(p,q,j);
            // cout<<j<<" is the candidate "<<k<<" between "<<p<<" and "<<q<<endl;
            if(k>(q-p+1)/b[i].k)
                ans[b[i].id] = min(ans[b[i].id],j);
        }
        for(auto j:candidates[q])
        {
            k = freq(p,q,j);
            // cout<<j<<" is the candidate "<<k<<" between "<<p<<" and "<<q<<endl;
            if(k>(q-p+1)/b[i].k)
                ans[b[i].id] = min(ans[b[i].id],j);
        }
    }

    solve(l,mid,to[1]);
    solve(mid+1,r,to[0]);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>Q;
    for(i=1; i<=n; i++)
    {
        cin>>a[i];
        sr[a[i]].push_back(i);
    }
    for(i=1; i<=Q; i++)
    {
        cin>>b[i].l>>b[i].r>>b[i].k;
        b[i].id = i;
    }
    vector <int> v;
    for(i=1; i<=n; i++)
        v.push_back(i);
    fill(ans+1,ans+Q+1,INT_MAX);
    solve(1,n,v);
    for(i=1; i<=Q; i++)
    {
        if(ans[i]!=INT_MAX)
            cout<<ans[i]<<endl;
        else cout<<-1<<endl;
    }
    return 0;
}
