#include<bits/stdc++.h>
//#define endl '\n'
using namespace std;
const int maxn = 1e4+3;
const int maxx = 2e3+3;
const int maxQ = 5e4+3;
long long dp1[maxn][maxx],dp2[maxn][maxx],ans[maxQ];
int i,j,p,q,n,m,k,Q;
struct Object
{
    int price,sat;
};
struct Query
{
    int l,r,x,id;
};
Object objects[maxn];///price and satisfaction
Query queries[maxQ];///L R X id

void solve(int l,int r,vector <int> tek)
{
    if(r<l || tek.empty())return ;
    if(l==r)
    {
        for(auto i:tek)
        {
            if(objects[queries[i].l].price<=queries[i].x)
                ans[queries[i].id] = objects[queries[i].l].sat;
        }
        return ;
    }
    vector <vector <int>> to;
    vector <int> now;
    int lmin = r,rmax = l,pr_max = 0;///borders
    to.resize(2);
    int mid = (l+r)/2;
    for(auto i:tek)
    {
        if(queries[i].l<=mid && queries[i].r>=mid)
        {
            now.push_back(i);
            pr_max = max(pr_max,queries[i].x);
            lmin = min(lmin,queries[i].l);
            rmax = max(rmax,queries[i].r);
        }
        else to[queries[i].l<=mid].push_back(i);
    }

    //cout<<lmin<<" "<<rmax<<" "<<pr_max<<endl;
    for(j=mid; j<=mid+1; j++)///dp zapochva ot tqh
    {
        for(i=1; i<=pr_max; i++)
            dp1[j][i] = -1,dp2[j][i] = -1;
        dp1[j][0] = dp2[j][0] = 0;
    }

    ///dp computation
    dp1[mid][objects[mid].price] = objects[mid].sat;
    for(i=mid-1; i>=lmin; i--)
    {
        for(j=pr_max; j>=0; j--)
        {
            dp1[i][j] = dp1[i+1][j];
            if(j-objects[i].price>=0 && dp1[i+1][j-objects[i].price]!=-1)
                dp1[i][j] = max(dp1[i][j],dp1[i+1][j-objects[i].price]+objects[i].sat);
        }
    }

    dp2[mid+1][objects[mid+1].price] = objects[mid+1].sat;
    for(i=mid+2; i<=rmax; i++)
    {
        for(j=pr_max; j>=0; j--)
        {

            dp2[i][j] = dp2[i-1][j];
            if(j-objects[i].price>=0 && dp2[i-1][j-objects[i].price]!=-1)
                dp2[i][j] = max(dp2[i-1][j],dp2[i-1][j-objects[i].price]+objects[i].sat);
        }
    }

    ///important - weight/price maximization

    for(i=lmin; i<=rmax; i++)
        for(j=1; j<=pr_max; j++)
            dp1[i][j] = max(dp1[i][j-1],dp1[i][j]),dp2[i][j] = max(dp2[i][j-1],dp2[i][j]);

    for(auto i:now)
    {
        for(j=0; j<=queries[i].x; j++)
            ans[queries[i].id] = max(ans[queries[i].id]
                                     ,dp1[queries[i].l][j]
                                     +dp2[queries[i].r][queries[i].x-j]);
    }

    solve(l,mid-1,to[1]);
    solve(mid+1,r,to[0]);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(i=1; i<=n; i++)
        cin>>objects[i].price>>objects[i].sat;

    cin>>Q;
    for(i=1; i<=Q; i++)
    {
        int l,r,x;
        cin>>queries[i].l>>queries[i].r>>queries[i].x;
        queries[i].id = i;
    }

    vector <int> v;
    for(i=1; i<=Q; i++)
        v.push_back(i);
    solve(1,n,v);

    for(i=1; i<=Q; i++)
        cout<<ans[i]<<endl;
    return 0;
}
